//-----------------------------------------------------------------
//                     bataille de cartes
//
//                                                  A.F. Mouyart
//                                                     12.3.1998
//-----------------------------------------------------------------

#include <iostream.h>

#define N 12            // nombre de cartes dans le jeu
#define FAMILLE 3       // nombre de cartes de chaque couleur
#define VRAI 1
#define FAUX 0

typedef int BOOLEEN;
typedef int JEU[N];

struct  CARTE { int valeur; int couleur; };
typedef CARTE ELEMENT;
struct  CELLULE { ELEMENT element; CELLULE *suivant; };

typedef CELLULE *PILE;
struct FILE { PILE first; PILE last; } ;

//-----------------------------------------------------------------
//             fonctions hasard
//-----------------------------------------------------------------

unsigned long int suivant = 1;

void randomize(unsigned int amorce)
{  suivant = amorce; }

int random(int borne)      // retourne un entier entre 0 et borne-1
{  suivant = suivant * 1103515245 + 12345;
   return (unsigned int) (suivant/65536) % borne;
}

void attendre(void)        // attend l'appui sur la touche "entree"
{ char c; do cin.get(c); while (c!='\n'); }

//-----------------------------------------------------------------
//             primitives de cartes
//-----------------------------------------------------------------


void melanger(JEU v)
{
   int i,j,x;
   
   for(i=0;i<N;i++) v[i]=i;
   for(i=N-1;i>=0;i--)
   {
      j=random(i+1);
      x=v[i];v[i]=v[j];v[j]=x;
   }
}

CARTE carte(int i)
{
   CARTE la_carte;
   la_carte.couleur = i / FAMILLE;
   la_carte.valeur  = i % FAMILLE;
   return la_carte;
}

int autre(int joueur)        // joueur = 0 ou 1
{  return 1-joueur; }

int compare (int a,int b)    // J0 joue a et J1 joue b
{
   if (a==b) return 2;       // match nul
   else if (a<b) return 1;   // J1 gagne
        else return 0;       // J0 gagne
}

void afficher_carte(CARTE la_carte)
{ cout << la_carte.valeur << "." << la_carte.couleur << " "; }

//-----------------------------------------------------------------
//             primitives de piles
//-----------------------------------------------------------------

void init_pile(PILE &la_pile)
{ la_pile = NULL; }

BOOLEEN pile_vide(PILE la_pile)
{ return la_pile == NULL; }

void empiler(ELEMENT valeur, PILE &la_pile)
{
   PILE p;
   p = new CELLULE; p->element = valeur; p->suivant = la_pile;
   la_pile = p;
}

void depiler(ELEMENT &valeur, PILE &la_pile)
{
   PILE p;
   p = la_pile;
   valeur = p->element;
   la_pile = la_pile->suivant;
   delete p;
}

ELEMENT sommet(PILE la_pile)
{ return la_pile->element; }

void afficher_pile(PILE la_pile)
{
   if(!pile_vide(la_pile))
      { afficher_carte(la_pile->element); afficher_pile(la_pile->suivant); }
}

//-----------------------------------------------------------------
//             primitives de files
//-----------------------------------------------------------------

void init_file(FILE &la_file)
{ la_file.first = NULL; la_file.last = NULL; }

BOOLEEN file_vide(FILE la_file)
{ return la_file.first == NULL; }

void entrer(ELEMENT valeur, FILE &la_file)
{
   CELLULE *p;
   p = new CELLULE; p->element = valeur; p->suivant = NULL;
   if (file_vide(la_file)) la_file.first = p;
              else la_file.last->suivant = p;
   la_file.last = p;
}

void sortir(ELEMENT &valeur, FILE &la_file)
{
   CELLULE *p;
   p = la_file.first;
   valeur = p->element;
   la_file.first = p->suivant;
   if (la_file.first == NULL) la_file.last = NULL;
   delete p;
}

void afficher_file(FILE la_file)
{
     afficher_pile (la_file.first);
}

//-----------------------------------------------------------------
//             programme principal
//-----------------------------------------------------------------

void main()
{
   int joueur,gagnant,i;
   BOOLEEN partie = VRAI;
   BOOLEEN manche;
   JEU j;
   CARTE la_carte;
   CARTE c[2];
   FILE main[2];
   PILE tas[2];
   
 // initialiser
   clrscr();
   cout << "randomize ? "; cin >> i; cout << endl; randomize(i);
   melanger(j);
   for(i=0;i<N;i++) cout << j[i] << " "; cout << endl << endl;
   for(joueur=0;joueur<=1;joueur++) {
      init_file(main[joueur]);
      init_pile(tas[joueur]);
   }
 // distribuer les cartes
   joueur = 0;
   for(i=0;i<N;i++) {
      la_carte = carte(j[i]);
      entrer(la_carte,main[joueur]);
      joueur = autre(joueur);
   }
   
 // partie
   cout << "dbut de la partie" << endl << endl;
   while (partie) {
     // tat du jeu
      for(joueur=0;joueur<=1;joueur++) {
         cout << "joueur " << joueur << endl;
         afficher_file(main[joueur]);
         cout << endl << endl;
      }
      
     // manche
      manche = VRAI;
      while (manche) {
         for (joueur=0;joueur<=1;joueur++) {
            if (!file_vide(main[joueur])) {
               sortir(c[joueur],main[joueur]);
               empiler(c[joueur],tas[joueur]);
               afficher_carte(c[joueur]);
            }  else { partie = FAUX; manche = FAUX; }
         }
         if (manche) {
            i = compare(c[0].valeur,c[1].valeur);
            if (i<2) { gagnant=i; manche=FAUX; }
            else cout << "bataille";
            cout << endl;
         }
      }
      cout << endl;  attendre();
      
     // le gagnant prend les deux tas
      if (partie) {
         for (joueur=0;joueur<=1;joueur++) {
            while(!pile_vide(tas[joueur])) {
               depiler(la_carte,tas[joueur]);
               entrer(la_carte,main[gagnant]);  
            } 
         }
      }
      if (file_vide(main[autre(gagnant)])) partie = FAUX;
   }
   if (!file_vide(main[gagnant])) cout << gagnant << " gagne" << endl;
   else cout << "match nul" << endl;
}
